/*
 *   lwrsundialsmodels - Adapts system equations of lwrmodels to be usable
 *                       with SUNDIALS IDA solver for implicit ODEs
 *                      
 *   Copyright (C) 2012 Vinzenz Bargsten <vb@bargsten.com>
 *
 *   This file is part of lwrsundialsmodels.
 *
 *   lwrsundialsmodels is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*

 */

#include <nvector/nvector_serial.h>
#include <sundials/sundials_direct.h>
#include "model.h"

#define ZERO RCONST(0.0);
#define ONE  RCONST(1.0);

typedef struct {
  realtype tau[NUMJ_MOD];
  } TauData;
/* Prototypes of functions called by IDA */

int resrob(realtype tres, N_Vector yy, N_Vector yp, 
           N_Vector resval, void * user_data);

int jacrob(int Neq, realtype tt,  realtype c, 
            N_Vector yy, N_Vector yp, N_Vector resvec,
            DlsMat JJ, void *user_data,
            N_Vector tempv1, N_Vector tempv2, N_Vector tempv3);
