#
#   python-lwrmodels - Python interface to the dynamic robot models of the
#                      lwrmodels C-library
#   Copyright (C) 2012 Vinzenz Bargsten <vb@bargsten.com>
#
#   This file is part of python-lwrmodels.
#
#   python-lwrmodels is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

cdef extern from "model.h":
    enum: NUMJ_MOD
    enum: NUMJ_ROB
    int SIMJOINTS[]
   
    void calc_residual(double resvec[2*NUMJ_MOD], double q[NUMJ_MOD], 
                       double dq[NUMJ_MOD], double dqp[NUMJ_MOD], 
                       double ddqp[NUMJ_MOD], double tau[NUMJ_MOD])

    void calc_jacobian(double resmat[2*NUMJ_MOD][2*NUMJ_MOD], double cj, 
                       double q[NUMJ_MOD], double dq[NUMJ_MOD], 
                       double dqp[NUMJ_MOD], double ddqp[NUMJ_MOD])

    void calc_inertia_matrix(double resmat[NUMJ_MOD][NUMJ_MOD], 
                             double q[NUMJ_MOD])

    void calc_gravity_torque_vector(double resvec[NUMJ_MOD], 
                                    double q[NUMJ_MOD])

    void calc_friction_torque_vector(double resvec[NUMJ_MOD], 
                                     double dq[NUMJ_MOD])

    void calc_coriolis_matrix(double resmat[NUMJ_MOD][NUMJ_MOD], 
                              double q[NUMJ_MOD], double dq[NUMJ_MOD])
    


    



