'''
Created on 09.02.2012

@author: vb
'''
import unittest
import numpy as np
from dynsim import SimulationRobotModel


def test_dynamics(state, tau):
    dx = np.zeros((2,))
    dx[0] = state[1]
    dx[1] = -0.1 * state[1] + 10.0 * tau[0]
    
    return dx
    
class Test(unittest.TestCase):
    
    
    def setUp(self):
        self.simMod = SimulationRobotModel(test_dynamics, 0.01, q0=[0.8], dq0=[0.5], numJoints=1, simulatedJoints=[0])
        


    def tearDown(self):
        pass


    def testIntegrationSteps(self):
        stateref = np.array([ 0.80514745,  0.52948525])
        state = np.zeros((2,))
        
        self.simMod.calc_next_state([0.3])
        state[:] = self.simMod.state
        
        np.testing.assert_allclose(stateref, state, 1e-5, 0,  
                                            'System Integration step 1 failed')
        
        stateref = np.array([0.80375688, -0.80737569])
        self.simMod.calc_next_state([-13.37])
        state[:] = self.simMod.state
        
        np.testing.assert_allclose(stateref, state, 1e-5, 0,  
                                            'System Integration step 2 failed')
        
    def testIntegrationStep2dof(self):
        pass


if __name__ == "__main__":
    #import sys;sys.argv = ['', 'Test.testName']
    unittest.main()